//
// Created by nicolas on 23/03/18.
//

#include "event_data.h"
#include "utils/debug.h"
#include "utils/string.h"

esc_event_data_t* esc_event_data_create(uuid_t* event_id, const char* event_type, bool_t is_json, buffer_t* data, buffer_t* metadata) {
    esc_event_data_t* event_data = malloc(sizeof(esc_event_data_t));
    event_data->event_id = uuid_copy(event_id);
    event_data->event_type = string_copy(event_type);
    event_data->is_json = is_json;
    event_data->data = data ? buffer_copy(data) : 0;
    event_data->metadata = metadata ? buffer_copy(metadata) : 0;
    return event_data;
}

void esc_event_data_destroy(esc_event_data_t* event_data) {
    uuid_destroy(event_data->event_id);
    free((void*)event_data->event_type);
    if (event_data->data) buffer_destroy(event_data->data);
    if (event_data->metadata) buffer_destroy(event_data->metadata);
    free(event_data);
}