//
// Created by nicolas on 22/03/18.
//

#ifndef ESC_RESULTS_H
#define ESC_RESULTS_H

#include "utils/uuid.h"
#include "utils/buffer.h"
#include "position.h"

typedef struct st_esc_recorded_event {
    uuid_t* event_id;
    const char* event_type;
    int64_t event_number;
    const char *event_stream_id;
    int64_t created_epoch;
    buffer_t* data;
    buffer_t* metadata;
} esc_recorded_event_t;

typedef struct st_esc_resolved_event {
    esc_recorded_event_t* event;
    esc_recorded_event_t* link;
    esc_position_t* original_position;
} esc_resolved_event_t;

struct st_all_events_slice {
    char* read_direction;
    esc_position_t* from_position;
    esc_position_t* next_position;
    size_t n_events;
    esc_resolved_event_t** events;
    int is_end_of_stream;
};
typedef struct st_all_events_slice esc_all_events_slice_t;

typedef struct st_esc_write_result_t {
    int64_t next_expected_version;
    esc_position_t* log_position;
} esc_write_result_t;

typedef struct st_esc_subscription_confirmation {

} esc_subscription_confirmation_t;

void esc_recorded_event_destroy(esc_recorded_event_t* recorded_event);
void esc_resolved_event_destroy(esc_resolved_event_t* resolved_event);
void esc_all_events_slice_destroy(esc_all_events_slice_t* all_events_slice);
void esc_write_result_destroy(esc_write_result_t* write_result);
void esc_subscription_confirmation_destroy(esc_subscription_confirmation_t* subscription_confirmation);

#endif //ESC_RESULTS_H
